diff -r ec894ddf18f6 trytond/modules/calendar/calendar_.py
--- a/trytond/modules/calendar/calendar_.py	Wed Jul 25 20:55:21 2012 +0200
+++ b/trytond/modules/calendar/calendar_.py	Mon Sep 24 20:36:40 2012 +0200
@@ -696,79 +666,72 @@
                             if x.status != 'declined'
                             and x.email != event.parent.organizer]
                 with Transaction().set_user(0):
-                    event_ids = self.search([
-                        ('uuid', '=', event.uuid),
-                        ('id', '!=', event.id),
-                        ('recurrence', '=', event.recurrence),
-                        ])
-                    for event2 in self.browse(event_ids):
+                    events2 = cls.search([
+                            ('uuid', '=', event.uuid),
+                            ('id', '!=', event.id),
+                            ('recurrence', '=', event.recurrence),
+                            ])
+                    for event2 in events2:
                         if event2.calendar.owner.email in attendee_emails:
                             attendee_emails.remove(
                                     event2.calendar.owner.email)
                         else:
-                            event_ids.remove(event2.id)
-                            self.delete(event2.id)
-                    if event_ids:
-                        self.write(event_ids, self._event2update(event))
+                            events2.remove(event2)
+                            cls.delete([event2])
+                    if events2:
+                        cls.write(events2, event._event2update())
                 if attendee_emails:
                     with Transaction().set_user(0):
-                        calendar_ids = calendar_obj.search([
-                            ('owner.email', 'in', attendee_emails),
-                            ])
+                        calendars = Calendar.search([
+                                ('owner.email', 'in', attendee_emails),
+                                ])
                         if not event.recurrence:
-                            for calendar_id in calendar_ids:
-                                new_id = self.copy(event.id, default={
-                                    'calendar': calendar_id,
-                                    'occurences': None,
-                                    })
+                            for calendar in calendars:
+                                new_event, = cls.copy([event], default={
+                                        'calendar': calendar.id,
+                                        'occurences': None,
+                                        })
                                 for occurence in event.occurences:
-                                    self.copy(occurence.id, default={
-                                        'calendar': calendar_id,
-                                        'parent': new_id,
-                                        })
+                                    cls.copy([occurence], default={
+                                            'calendar': calendar.id,
+                                            'parent': new_event.id,
+                                            })
                         else:
-                            parent_ids = self.search([
+                            parents = cls.search([
                                     ('uuid', '=', event.uuid),
                                     ('calendar.owner.email', 'in',
                                         attendee_emails),
                                     ('id', '!=', event.id),
                                     ('recurrence', '=', None),
                                     ])
-                            for parent in self.browse(parent_ids):
-                                self.copy(event.id, default={
-                                    'calendar': parent.calendar.id,
-                                    'parent': parent.id,
-                                    })
+                            for parent in parents:
+                                cls.copy([event], default={
+                                        'calendar': parent.calendar.id,
+                                        'parent': parent.id,
+                                        })
         # Restart the cache for event
-        collection_obj.event.reset()
-        return res
+        Collection._event_cache.reset()
 
-    def copy(self, ids, default=None):
-        int_id = isinstance(ids, (int, long))
-        if int_id:
-            ids = [ids]
-
+    @classmethod
+    def copy(cls, events, default=None):
         if default is None:
             default = {}
 
-        new_ids = []
-        for event_id in ids:
+        new_events = []
+        for event in events:
             current_default = default.copy()
-            current_default['uuid'] = self.default_uuid()
-            new_id = super(Event, self).copy(event_id, default=current_default)
-            new_ids.append(new_id)
+            current_default['uuid'] = cls.default_uuid()
+            new_events.append(super(Event, cls).copy([event],
+                    default=current_default))
+        return new_events
 
-        if int_id:
-            return new_ids[0]
-        return new_ids
+    @classmethod
+    def delete(cls, events):
+        pool = Pool()
+        Attendee = pool.get('calendar.event.attendee')
+        Collection = pool.get('webdav.collection')
 
-    def delete(self, ids):
-        attendee_obj = Pool().get('calendar.event.attendee')
-        collection_obj = Pool().get('webdav.collection')
-
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        for event in self.browse(ids):
+        for event in events:
             if event.calendar.owner \
                     and (event.organizer == event.calendar.owner.email \
                     or (event.parent \
@@ -781,13 +744,13 @@
                             if x.email != event.parent.organizer]
                 if attendee_emails:
                     with Transaction().set_user(0):
-                        event_ids = self.search([
-                            ('uuid', '=', event.uuid),
-                            ('calendar.owner.email', 'in', attendee_emails),
-                            ('id', '!=', event.id),
-                            ('recurrence', '=', event.recurrence),
-                            ])
-                        self.delete(event_ids)
+                        cls.delete(cls.search([
+                                    ('uuid', '=', event.uuid),
+                                    ('calendar.owner.email', 'in',
+                                        attendee_emails),
+                                    ('id', '!=', event.id),
+                                    ('recurrence', '=', event.recurrence),
+                                    ]))
             elif event.organizer \
                     or (event.parent and event.parent.organizer):
                 if event.organizer:
@@ -795,43 +758,37 @@
                 else:
                     organizer = event.parent.organizer
                 with Transaction().set_user(0):
-                    event_ids = self.search([
-                        ('uuid', '=', event.uuid),
-                        ('calendar.owner.email', '=', organizer),
-                        ('id', '!=', event.id),
-                        ('recurrence', '=', event.recurrence),
-                        ], limit=1)
-                    if event_ids:
-                        event2 = self.browse(event_ids[0])
+                    events2 = cls.search([
+                            ('uuid', '=', event.uuid),
+                            ('calendar.owner.email', '=', organizer),
+                            ('id', '!=', event.id),
+                            ('recurrence', '=', event.recurrence),
+                            ], limit=1)
+                    if events2:
+                        event2, = events2
                         for attendee in event2.attendees:
                             if attendee.email == event.calendar.owner.email:
-                                attendee_obj.write(attendee.id, {
-                                    'status': 'declined',
-                                    })
-        res = super(Event, self).delete(ids)
+                                Attendee.write([attendee], {
+                                        'status': 'declined',
+                                        })
+        super(Event, cls).delete(events)
         # Restart the cache for event
-        collection_obj.event.reset()
-        return res
+        Collection._event_cache.reset()
 
-    def ical2values(self, event_id, ical, calendar_id, vevent=None):
+    @classmethod
+    def ical2values(cls, event_id, ical, calendar_id, vevent=None):
         '''
-        Convert iCalendar to values for create or write
-
-        :param event_id: the event id for write or None for create
-        :param ical: a ical instance of vobject
-        :param calendar_id: the calendar id of the event
-        :param vevent: the vevent of the ical to use if None use the first one
-        :return: a dictionary with values
+        Convert iCalendar to values for create or write with
+        the event id for write or None for create
         '''
         pool = Pool()
-        category_obj = pool.get('calendar.category')
-        location_obj = pool.get('calendar.location')
-        alarm_obj = pool.get('calendar.event.alarm')
-        attendee_obj = pool.get('calendar.event.attendee')
-        rdate_obj = pool.get('calendar.event.rdate')
-        exdate_obj = pool.get('calendar.event.exdate')
-        rrule_obj = pool.get('calendar.event.rrule')
-        exrule_obj = pool.get('calendar.event.exrule')
+        Category = pool.get('calendar.category')
+        Location = pool.get('calendar.location')
+        Rdate = pool.get('calendar.event.rdate')
+        Exdate = pool.get('calendar.event.exdate')
+        Rrule = pool.get('calendar.rrule')
+        Exrule = pool.get('calendar.event.exrule')
+        Valarm = pool.get('calendar.event.valarm')
 
         vevents = []
         if not vevent:
@@ -844,7 +801,7 @@
 
         event = None
         if event_id:
-            event = self.browse(event_id)
+            event = cls(event_id)
 
         res = {}
         if not event:
@@ -902,24 +859,23 @@
             res['status'] = ''
         if hasattr(vevent, 'categories'):
             with Transaction().set_context(active_test=False):
-                category_ids = category_obj.search([
-                    ('name', 'in', [x for x in vevent.categories.value]),
-                    ])
-            categories = category_obj.browse(category_ids)
+                categories = Category.search([
+                        ('name', 'in', [x for x in vevent.categories.value]),
+                        ])
             category_names2ids = {}
             for category in categories:
                 category_names2ids[category.name] = category.id
             for category in vevent.categories.value:
                 if category not in category_names2ids:
-                    category_ids.append(category_obj.create({
-                        'name': category,
-                        }))
-            res['categories'] = [('set', category_ids)]
+                    categories.append(Category.create({
+                                'name': category,
+                                }))
+            res['categories'] = [('set', map(int, categories))]
         else:
             res['categories'] = [('unlink_all',)]
         if hasattr(vevent, 'class'):
             if getattr(vevent, 'class').value.lower() in \
-                    dict(self.classification.selection):
+                    dict(cls.classification.selection):
                 res['classification'] = getattr(vevent, 'class').value.lower()
             else:
                 res['classification'] = 'public'
@@ -927,16 +883,16 @@
             res['classification'] = 'public'
         if hasattr(vevent, 'location'):
             with Transaction().set_context(active_test=False):
-                location_ids = location_obj.search([
-                    ('name', '=', vevent.location.value),
-                    ], limit=1)
-            if not location_ids:
-                location_id = location_obj.create({
-                    'name': vevent.location.value,
-                    })
+                locations = Location.search([
+                        ('name', '=', vevent.location.value),
+                        ], limit=1)
+            if not locations:
+                location = Location.create({
+                        'name': vevent.location.value,
+                        })
             else:
-                location_id = location_ids[0]
-            res['location'] = location_id
+                location, = locations
+            res['location'] = location.id
         else:
             res['location'] = None
 
@@ -963,7 +919,7 @@
         if hasattr(vevent, 'attendee'):
             while vevent.attendee_list:
                 attendee = vevent.attendee_list.pop()
-                vals = attendee_obj.attendee2values(attendee)
+                vals = Attendee.attendee2values(attendee)
                 if vals['email'] in attendees_todel:
                     res['attendees'].append(('write',
                         attendees_todel[vals['email']], vals))
@@ -978,9 +934,8 @@
         if hasattr(vevent, 'rdate'):
             while vevent.rdate_list:
                 rdate = vevent.rdate_list.pop()
-                for date in rdate.value:
-                    vals = rdate_obj.date2values(date)
-                    res['rdates'].append(('create', vals))
+                for rdate in rdate.value:
+                    res['rdates'].append(('create', Rdate.date2values(rdate)))
 
         res['exdates'] = []
         if event:
@@ -988,9 +943,9 @@
         if hasattr(vevent, 'exdate'):
             while vevent.exdate_list:
                 exdate = vevent.exdate_list.pop()
-                for date in exdate.value:
-                    vals = exdate_obj.date2values(date)
-                    res['exdates'].append(('create', vals))
+                for exdate in exdate.value:
+                    res['exdates'].append(('create',
+                            Exdate.date2values(exdate)))
 
         res['rrules'] = []
         if event:
@@ -998,8 +953,7 @@
         if hasattr(vevent, 'rrule'):
             while vevent.rrule_list:
                 rrule = vevent.rrule_list.pop()
-                vals = rrule_obj.rule2values(rrule)
-                res['rrules'].append(('create', vals))
+                res['rrules'].append(('create', Rrule.rule2values(rrule)))
 
         res['exrules'] = []
         if event:
@@ -1007,8 +961,7 @@
         if hasattr(vevent, 'exrule'):
             while vevent.exrule_list:
                 exrule = vevent.exrule_list.pop()
-                vals = exrule_obj.rule2values(exrule)
-                res['exrules'].append(('create', vals))
+                res['exrules'].append(('create', Exrule.rule2values(exrule)))
 
         if event:
             res.setdefault('alarms', [])
@@ -1017,8 +970,7 @@
             res.setdefault('alarms', [])
             while vevent.valarm_list:
                 valarm = vevent.valarm_list.pop()
-                vals = alarm_obj.valarm2values(valarm)
-                res['alarms'].append(('create', vals))
+                res['alarms'].append(('create', Valarm.valarm2values(valarm)))
 
         if hasattr(ical, 'vtimezone'):
             if ical.vtimezone.tzid.value in pytz.common_timezones:
@@ -1035,7 +987,7 @@
             occurences_todel = [x.id for x in event.occurences]
         for vevent in vevents:
             event_id = None
-            vals = self.ical2values(event_id, ical, calendar_id, vevent=vevent)
+            vals = cls.ical2values(event_id, ical, calendar_id, vevent=vevent)
             if event:
                 for occurence in event.occurences:
                     if vals['recurrence'] == \
@@ -1056,31 +1008,17 @@
             res['occurences'].insert(0, ('delete', occurences_todel))
         return res
 
-    def event2ical(self, event):
+    def event2ical(self):
         '''
         Return an iCalendar instance of vobject for event
-
-        :param event: a BrowseRecord of calendar.event
-            or a calendar.event id
-        :param calendar: a BrowseRecord of calendar.calendar
-            or a calendar.calendar id
-        :return: an iCalendar instance of vobject
         '''
         pool = Pool()
-        user_obj = pool.get('res.user')
-        alarm_obj = pool.get('calendar.event.alarm')
-        attendee_obj = pool.get('calendar.event.attendee')
-        rdate_obj = pool.get('calendar.event.rdate')
-        exdate_obj = pool.get('calendar.event.exdate')
-        rrule_obj = pool.get('calendar.event.rrule')
-        exrule_obj = pool.get('calendar.event.exrule')
+        User = pool.get('res.user')
 
-        if isinstance(event, (int, long)):
-            event = self.browse(event)
-
-        user = user_obj.browse(Transaction().user)
-        if event.timezone:
-            tzevent = dateutil.tz.gettz(event.timezone)
+        user = User(Transaction().user)
+        if self.timezone:
+            tzevent = pytz.timezone(self.timezone)
+            tzevent = dateutil.tz.gettz(self.timezone)
         elif user.timezone:
             tzevent = dateutil.tz.gettz(user.timezone)
         else:
@@ -1088,248 +1026,222 @@
 
         ical = vobject.iCalendar()
         vevent = ical.add('vevent')
-        if event.vevent:
-            ical.vevent = vobject.readOne(str(event.vevent))
+        if self.vevent:
+            ical.vevent = vobject.readOne(str(self.vevent))
             vevent = ical.vevent
             ical.vevent.transformToNative()
-        if event.summary:
+        if self.summary:
             if not hasattr(vevent, 'summary'):
                 vevent.add('summary')
-            vevent.summary.value = event.summary
+            vevent.summary.value = self.summary
         elif hasattr(vevent, 'summary'):
             del vevent.summary
-        if event.description:
+        if self.description:
             if not hasattr(vevent, 'description'):
                 vevent.add('description')
-            vevent.description.value = event.description
+            vevent.description.value = self.description
         elif hasattr(vevent, 'description'):
             del vevent.description
         if not hasattr(vevent, 'dtstart'):
             vevent.add('dtstart')
-        if event.all_day:
-            vevent.dtstart.value = event.dtstart.date()
+        if self.all_day:
+            vevent.dtstart.value = self.dtstart.date()
         else:
-            vevent.dtstart.value = event.dtstart.replace(tzinfo=tzlocal)\
+            vevent.dtstart.value = self.dtstart.replace(tzinfo=tzlocal)\
                     .astimezone(tzevent)
-        if event.dtend:
+        if self.dtend:
             if not hasattr(vevent, 'dtend'):
                 vevent.add('dtend')
-            if event.all_day:
-                vevent.dtend.value = event.dtend.date()
+            if self.all_day:
+                vevent.dtend.value = self.dtend.date()
             else:
-                vevent.dtend.value = event.dtend.replace(tzinfo=tzlocal)\
+                vevent.dtend.value = self.dtend.replace(tzinfo=tzlocal)\
                         .astimezone(tzevent)
         elif hasattr(vevent, 'dtend'):
             del vevent.dtend
         if not hasattr(vevent, 'created'):
             vevent.add('created')
-        vevent.created.value = event.create_date.replace(tzinfo=tzlocal)
+        vevent.created.value = self.create_date.replace(tzinfo=tzlocal)
         if not hasattr(vevent, 'dtstamp'):
             vevent.add('dtstamp')
-        date = event.write_date or event.create_date
+        date = self.write_date or self.create_date
         vevent.dtstamp.value = date.replace(tzinfo=tzlocal)
         if not hasattr(vevent, 'last-modified'):
             vevent.add('last-modified')
         vevent.last_modified.value = date.replace(tzinfo=tzlocal)
-        if event.recurrence and event.parent:
+        if self.recurrence and self.parent:
             if not hasattr(vevent, 'recurrence-id'):
                 vevent.add('recurrence-id')
-            if event.all_day:
-                vevent.recurrence_id.value = event.recurrence.date()
+            if self.all_day:
+                vevent.recurrence_id.value = self.recurrence.date()
             else:
-                vevent.recurrence_id.value = event.recurrence\
+                vevent.recurrence_id.value = self.recurrence\
                         .replace(tzinfo=tzlocal).astimezone(tzevent)
         elif hasattr(vevent, 'recurrence-id'):
             del vevent.recurrence_id
-        if event.status:
+        if self.status:
             if not hasattr(vevent, 'status'):
                 vevent.add('status')
-            vevent.status.value = event.status.upper()
+            vevent.status.value = self.status.upper()
         elif hasattr(vevent, 'status'):
             del vevent.status
         if not hasattr(vevent, 'uid'):
             vevent.add('uid')
-        vevent.uid.value = event.uuid
+        vevent.uid.value = self.uuid
         if not hasattr(vevent, 'sequence'):
             vevent.add('sequence')
-        vevent.sequence.value = str(event.sequence) or '0'
-        if event.categories:
+        vevent.sequence.value = str(self.sequence) or '0'
+        if self.categories:
             if not hasattr(vevent, 'categories'):
                 vevent.add('categories')
-            vevent.categories.value = [x.name for x in event.categories]
+            vevent.categories.value = [x.name for x in self.categories]
         elif hasattr(vevent, 'categories'):
             del vevent.categories
         if not hasattr(vevent, 'class'):
             vevent.add('class')
-            getattr(vevent, 'class').value = event.classification.upper()
+            getattr(vevent, 'class').value = self.classification.upper()
         elif getattr(vevent, 'class').value.lower() in \
-                dict(self.classification.selection):
-            getattr(vevent, 'class').value = event.classification.upper()
-        if event.location:
+                dict(self.__class__.classification.selection):
+            getattr(vevent, 'class').value = self.classification.upper()
+        if self.location:
             if not hasattr(vevent, 'location'):
                 vevent.add('location')
-            vevent.location.value = event.location.name
+            vevent.location.value = self.location.name
         elif hasattr(vevent, 'location'):
             del vevent.location
 
         if not hasattr(vevent, 'transp'):
             vevent.add('transp')
-        vevent.transp.value = event.transp.upper()
+        vevent.transp.value = self.transp.upper()
 
-        if event.organizer:
+        if self.organizer:
             if not hasattr(vevent, 'organizer'):
                 vevent.add('organizer')
-            vevent.organizer.value = 'MAILTO:' + event.organizer
+            vevent.organizer.value = 'MAILTO:' + self.organizer
         elif hasattr(vevent, 'organizer'):
             del vevent.organizer
 
         vevent.attendee_list = []
-        for attendee in event.attendees:
-            vevent.attendee_list.append(attendee_obj.attendee2attendee(
-                attendee))
+        for attendee in self.attendees:
+            vevent.attendee_list.append(attendee.attendee2attendee())
 
-        if event.rdates:
+        if self.rdates:
             vevent.add('rdate')
             vevent.rdate.value = []
-            for rdate in event.rdates:
-                vevent.rdate.value.append(rdate_obj.date2date(rdate))
+            for rdate in self.rdates:
+                vevent.rdate.value.append(rdate.date2date())
 
-        if event.exdates:
+        if self.exdates:
             vevent.add('exdate')
             vevent.exdate.value = []
-            for exdate in event.exdates:
-                vevent.exdate.value.append(exdate_obj.date2date(exdate))
+            for exdate in self.exdates:
+                vevent.exdate.value.append(exdate.date2date())
 
-        if event.rrules:
-            for rrule in event.rrules:
-                vevent.add('rrule').value = rrule_obj.rule2rule(rrule)
+        if self.rrules:
+            for rrule in self.rrules:
+                vevent.add('rrule').value = rrule.rule2rule()
 
-        if event.exrules:
-            for exrule in event.exrules:
-                vevent.add('exrule').value = exrule_obj.rule2rule(exrule)
+        if self.exrules:
+            for exrule in self.exrules:
+                vevent.add('exrule').value = exrule.rule2rule()
 
         vevent.valarm_list = []
-        for alarm in event.alarms:
-            valarm = alarm_obj.alarm2valarm(alarm)
+        for alarm in self.alarms:
+            valarm = alarm.alarm2valarm()
             if valarm:
                 vevent.valarm_list.append(valarm)
 
-        for occurence in event.occurences:
-            oical = self.event2ical(occurence)
+        for occurence in self.occurences:
+            oical = occurence.event2ical()
             ical.vevent_list.append(oical.vevent)
         return ical
 
-Event()
-
 
 class EventCategory(ModelSQL):
     'Event - Category'
-    _description = __doc__
-    _name = 'calendar.event-calendar.category'
-
+    __name__ = 'calendar.event-calendar.category'
     event = fields.Many2One('calendar.event', 'Event', ondelete='CASCADE',
             required=True, select=True)
     category = fields.Many2One('calendar.category', 'Category',
             ondelete='CASCADE', required=True, select=True)
 
-EventCategory()
-
 
 class Alarm(ModelSQL):
     'Alarm'
-    _description = __doc__
-    _name = 'calendar.alarm'
-
+    __name__ = 'calendar.alarm'
     valarm = fields.Binary('valarm')
 
-    def valarm2values(self, valarm):
+    @classmethod
+    def valarm2values(cls, valarm):
         '''
         Convert a valarm object into values for create or write
+        '''
+        return {
+            'valarm': valarm.serialize(),
+            }
 
-        :param valarm: the valarm object
-        :return: a dictionary with values
-        '''
-        res = {}
-        res['valarm'] = valarm.serialize()
-        return res
-
-    def alarm2valarm(self, alarm):
+    def alarm2valarm(self):
         '''
         Return a valarm instance of vobject for alarm
-
-        :param alarm: a BrowseRecord of calendar.event.alarm
-        :return: a valarm instance of vobject
         '''
-        valarm = None
-        if alarm.valarm:
-            valarm = vobject.readOne(str(alarm.valarm))
-        return valarm
-
-Alarm()
+        if self.valarm:
+            return vobject.readOne(str(self.valarm))
 
 
 class EventAlarm(ModelSQL):
     'Alarm'
-    _description = __doc__
-    _name = 'calendar.event.alarm'
+    __name__ = 'calendar.event.alarm'
     _inherits = {'calendar.alarm': 'calendar_alarm'}
-
     calendar_alarm = fields.Many2One('calendar.alarm', 'Calendar Alarm',
             required=True, ondelete='CASCADE', select=True)
     event = fields.Many2One('calendar.event', 'Event', ondelete='CASCADE',
             required=True, select=True)
 
-    def create(self, values):
-        event_obj = Pool().get('calendar.event')
+    @classmethod
+    def create(cls, values):
+        Event = Pool().get('calendar.event')
         if values.get('event'):
             # Update write_date of event
-            event_obj.write(values['event'], {})
-        return super(EventAlarm, self).create(values)
+            Event.write(values['event'], {})
+        return super(EventAlarm, cls).create(values)
 
-    def write(self, ids, values):
-        event_obj = Pool().get('calendar.event')
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        event_ids = [x.event.id for x in self.browse(ids)]
+    @classmethod
+    def write(cls, event_alarms, values):
+        Event = Pool().get('calendar.event')
+        events = [x.event for x in event_alarms]
         if values.get('event'):
-            event_ids.append(values['event'])
-        if event_ids:
+            events.append(Event(values['event']))
+        if events:
             # Update write_date of event
-            event_obj.write(event_ids, {})
-        return super(EventAlarm, self).write(ids, values)
+            Event.write(events, {})
+        return super(EventAlarm, cls).write(event_alarms, values)
 
-    def delete(self, ids):
-        event_obj = Pool().get('calendar.event')
-        alarm_obj = Pool().get('calendar.alarm')
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        event_alarms = self.browse(ids)
-        alarm_ids = [a.calendar_alarm.id for a in event_alarms]
-        event_ids = [x.event.id for x in event_alarms]
-        if event_ids:
+    @classmethod
+    def delete(cls, event_alarms):
+        pool = Pool()
+        Event = pool.get('calendar.event')
+        Alarm = pool.get('calendar.alarm')
+        alarms = [a.calendar_alarm for a in event_alarms]
+        events = [x.event for x in event_alarms]
+        if events:
             # Update write_date of event
-            event_obj.write(event_ids, {})
-        res = super(EventAlarm, self).delete(ids)
-        if alarm_ids:
-            alarm_obj.delete(alarm_ids)
-        return res
+            Event.write(events, {})
+        super(EventAlarm, cls).delete(event_alarms)
+        if alarms:
+            Alarm.delete(alarms)
 
-    def valarm2values(self, alarm):
-        alarm_obj = Pool().get('calendar.alarm')
-        return alarm_obj.valarm2values(alarm)
+    @classmethod
+    def valarm2values(cls, alarm):
+        Alarm = Pool().get('calendar.alarm')
+        return Alarm.valarm2values(alarm)
 
-    def alarm2valarm(self, alarm):
-        alarm_obj = Pool().get('calendar.alarm')
-        return alarm_obj.alarm2valarm(alarm)
-
-EventAlarm()
+    def alarm2valarm(self):
+        return self.calendar_alarm.alarm2valarm()
 
 
 class Attendee(ModelSQL, ModelView):
     'Attendee'
-    _description = __doc__
-    _name = 'calendar.attendee'
-
+    __name__ = 'calendar.attendee'
     email = fields.Char('Email', required=True, states={
         'readonly': Eval('id', 0) > 0,
         }, depends=['id'])
@@ -1343,20 +1255,19 @@
         ], 'Participation Status')
     attendee = fields.Binary('attendee')
 
-    def default_status(self):
+    @staticmethod
+    def default_status():
         return ''
 
-    def _attendee2update(self, attendee):
-        res = {}
-        res['status'] = attendee.status
-        return res
+    def _attendee2update(self):
+        return {
+            'status': self.status,
+            }
 
-    def attendee2values(self, attendee):
+    @classmethod
+    def attendee2values(cls, attendee):
         '''
         Convert a attendee object into values for create or write
-
-        :param attendee: the attendee object
-        :return: a dictionary with values
         '''
         res = {}
         if attendee.value.lower().startswith('mailto:'):
